package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@OptIn(ExperimentalUnsignedTypes::class)
class STRING(provider: DatabaseType.Provider) :
	DatabaseType._VirtualType<String, UByteArray, DatabaseType.BINARY_DATA>(provider.BINARY_DATA) {

	override val name: String get() = "STRING"

	override fun _unwrap(w: UByteArray): String = w.asByteArray().decodeToString()

	override fun _wrap(w: String): UByteArray = w.encodeToByteArray().asUByteArray()

	override fun _equals(l: String, r: String): Boolean = l == r

	override fun _compare(l: String, r: String): Int = l.compareTo(r)

}