package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@OptIn(ExperimentalUnsignedTypes::class)
class U8(provider: DatabaseType.Provider) :
	DatabaseType._VirtualType<UByte, UByteArray, DatabaseType.BINARY_DATA>(provider.BINARY_DATA(8u, true)) {

	override val name: String get() = "INT_U8"

	override fun _unwrap(w: UByteArray): UByte {
		return w[0]
	}

	override fun _wrap(w: UByte): UByteArray = ubyteArrayOf(w)

	override fun _equals(l: UByte, r: UByte): Boolean = l == r

	override fun _compare(l: UByte, r: UByte): Int = l.compareTo(r)

}