package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp

import ru.landgrafhomyak.db.serdha0.api.misc.Reducer
import ru.landgrafhomyak.db.serdha0.api.runtime.InputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class HAS_ROWS private constructor(context: Reducer.Constructor.Scope<HAS_ROWS>) : Reducer.Action<HAS_ROWS> {
	val C_Flag = context.outputColumn("flag", context.types.BOOLEAN, false)

	override fun calculate(acc: OutputRow<HAS_ROWS>, row: OutputRow<HAS_ROWS>, newAcc: InputRow<HAS_ROWS>) {
		newAcc[this.C_Flag] = true
	}

	companion object Constructor : Reducer.Constructor<HAS_ROWS> {
		override fun createReducer(context: Reducer.Constructor.Scope<HAS_ROWS>) =
			HAS_ROWS(context)
	}
}