package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.S64
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class T_Chats private constructor(context: TableConstructor.Scope<T_Chats>) {
	val C_RowId = context.rowId_column
	val C_TgCid = context.column("telegram::chat_id", context.types.S64)

	val U_RowId = context.rowId_uniqueConstraint
	val U_TgCid = context.uniqueIndex("telegram::chat_id", true, this.C_TgCid)

	companion object Constructor : TableConstructor<T_Chats> {
		override fun createTable(context: TableConstructor.Scope<T_Chats>) =
			T_Chats(context)
	}
}